/**
 * Copyright(c) Live2D Inc. All rights reserved.
 *
 * Use of this source code is governed by the Live2D Open Software license
 * that can be found at https://www.live2d.com/eula/live2d-open-software-license-agreement_en.html.
 */
/**
 * @brief パラメータIDのデフォルト値を保持する定数<br>
 *         デフォルト値の仕様は以下のマニュアルに基づく<br>
 *         https://docs.live2d.com/cubism-editor-manual/standard-parametor-list/
 */
export declare const CubismDefaultParameterId: Readonly<Record<string, string>>;
export declare namespace Live2DCubismFramework {
    const HitAreaBody: string;
    const HitAreaHead: string;
    const HitAreaPrefix: string;
    const ParamAngleX: string;
    const ParamAngleY: string;
    const ParamAngleZ: string;
    const ParamArmLA: string;
    const ParamArmLB: string;
    const ParamArmRA: string;
    const ParamArmRB: string;
    const ParamBaseX: string;
    const ParamBaseY: string;
    const ParamBodyAngleX: string;
    const ParamBodyAngleY: string;
    const ParamBodyAngleZ: string;
    const ParamBreath: string;
    const ParamBrowLAngle: string;
    const ParamBrowLForm: string;
    const ParamBrowLX: string;
    const ParamBrowLY: string;
    const ParamBrowRAngle: string;
    const ParamBrowRForm: string;
    const ParamBrowRX: string;
    const ParamBrowRY: string;
    const ParamBustX: string;
    const ParamBustY: string;
    const ParamCheek: string;
    const ParamEyeBallForm: string;
    const ParamEyeBallX: string;
    const ParamEyeBallY: string;
    const ParamEyeLOpen: string;
    const ParamEyeLSmile: string;
    const ParamEyeROpen: string;
    const ParamEyeRSmile: string;
    const ParamHairBack: string;
    const ParamHairFluffy: string;
    const ParamHairFront: string;
    const ParamHairSide: string;
    const ParamHandL: string;
    const ParamHandR: string;
    const ParamMouthForm: string;
    const ParamMouthOpenY: string;
    const ParamNONE: string;
    const ParamShoulderY: string;
    const PartsArmLPrefix: string;
    const PartsArmPrefix: string;
    const PartsArmRPrefix: string;
    const PartsIdCore: string;
}
//# sourceMappingURL=cubismdefaultparameterid.d.ts.map