/**
 * @author       Richard Davey <rich@photonstorm.com>
 * @copyright    2019 Photon Storm Ltd.
 * @license      {@link https://opensource.org/licenses/MIT|MIT License}
 */

import Circle from './Circle';
import Area from './Area';
import Circumference from './Circumference.js';
import CircumferencePoint from './CircumferencePoint.js';
import Clone from './Clone.js';
import Contains from './Contains.js';
import ContainsPoint from './ContainsPoint.js';
import ContainsRect from './ContainsRect.js';
import CopyFrom from './CopyFrom.js';
import Equals from './Equals.js';
import GetBounds from './GetBounds.js';
import GetPoint from './GetPoint.js';
import GetPoints from './GetPoints.js';
import Offset from './Offset.js';
import OffsetPoint from './OffsetPoint.js';
import Random from './Random.js';

Circle.Area = Area;
Circle.Circumference = Circumference;
Circle.CircumferencePoint = CircumferencePoint;
Circle.Clone = Clone;
Circle.Contains = Contains;
Circle.ContainsPoint = ContainsPoint;
Circle.ContainsRect = ContainsRect;
Circle.CopyFrom = CopyFrom;
Circle.Equals = Equals;
Circle.GetBounds = GetBounds;
Circle.GetPoint = GetPoint;
Circle.GetPoints = GetPoints;
Circle.Offset = Offset;
Circle.OffsetPoint = OffsetPoint;
Circle.Random = Random;

export default Circle;
