/**
 * @author       Richard Davey <rich@photonstorm.com>
 * @copyright    2019 Photon Storm Ltd.
 * @license      {@link https://opensource.org/licenses/MIT|MIT License}
 */

import Ellipse from './Ellipse.js';
import Area from './Area.js';
import Circumference from './Circumference.js';
import CircumferencePoint from './CircumferencePoint.js';
import Clone from './Clone.js';
import Contains from './Contains.js';
import ContainsPoint from './ContainsPoint.js';
import ContainsRect from './ContainsRect.js';
import CopyFrom from './CopyFrom.js';
import Equals from './Equals.js';
import GetBounds from './GetBounds.js';
import GetPoint from './GetPoint.js';
import GetPoints from './GetPoints.js';
import Offset from './Offset.js';
import OffsetPoint from './OffsetPoint.js';
import Random from './Random.js';

Ellipse.Area = Area;
Ellipse.Circumference = Circumference;
Ellipse.CircumferencePoint = CircumferencePoint;
Ellipse.Clone = Clone;
Ellipse.Contains = Contains;
Ellipse.ContainsPoint = ContainsPoint;
Ellipse.ContainsRect = ContainsRect;
Ellipse.CopyFrom = CopyFrom;
Ellipse.Equals = Equals;
Ellipse.GetBounds = GetBounds;
Ellipse.GetPoint = GetPoint;
Ellipse.GetPoints = GetPoints;
Ellipse.Offset = Offset;
Ellipse.OffsetPoint = OffsetPoint;
Ellipse.Random = Random;

export default Ellipse;
