/**
 * @author       Richard Davey <rich@photonstorm.com>
 * @copyright    2019 Photon Storm Ltd.
 * @license      {@link https://opensource.org/licenses/MIT|MIT License}
 */

/**
 * @namespace Phaser.Geom
 */

import Circle from './circle.js';
import Ellipse from './ellipse.js';
import Intersects from './intersects.js';
import Line from './line.js';
import Point from './point.js';
import Polygon from './point.js';
import Rectangle from './rectangle.js';
import Triangle from './triangle.js';

export default {

    Circle: Circle,
    Ellipse: Ellipse,
    Intersects: Intersects,
    Line: Line,
    Point: Point,
    Polygon: Polygon,
    Rectangle: Rectangle,
    Triangle: Triangle

};
