/**
 * @author       Richard Davey <rich@photonstorm.com>
 * @copyright    2019 Photon Storm Ltd.
 * @license      {@link https://opensource.org/licenses/MIT|MIT License}
 */

/**
 * @namespace Phaser.Geom.Intersects
 */

import CircleToCircle from './CircleToCircle.js';
import CircleToRectangle from './CircleToRectangle.js';
import GetCircleToCircle from './GetCircleToCircle.js';
import GetCircleToRectangle from './GetCircleToRectangle.js';
import GetLineToCircle from './GetLineToCircle.js';
import GetLineToRectangle from './GetLineToRectangle.js';
import GetRectangleIntersection from './GetRectangleIntersection.js';
import GetRectangleToRectangle from './GetRectangleToRectangle.js';
import GetRectangleToTriangle from './GetRectangleToTriangle.js';
import GetTriangleToCircle from './GetTriangleToCircle.js';
import GetTriangleToLine from './GetTriangleToLine.js';
import GetTriangleToTriangle from './GetTriangleToTriangle.js';
import LineToCircle from './LineToCircle.js';
import LineToLine from './LineToLine.js';
import LineToRectangle from './LineToRectangle.js';
import PointToLine from './PointToLine.js';
import PointToLineSegment from './PointToLineSegment.js';
import RectangleToRectangle from './RectangleToRectangle.js';
import RectangleToTriangle from './RectangleToTriangle.js';
import RectangleToValues from './RectangleToValues.js';
import TriangleToCircle from './TriangleToCircle.js';
import TriangleToLine from './TriangleToLine.js';
import TriangleToTriangle from './TriangleToTriangle.js';

export default {

    CircleToCircle: CircleToCircle,
    CircleToRectangle: CircleToRectangle,
    GetCircleToCircle: GetCircleToCircle,
    GetCircleToRectangle: GetCircleToRectangle,
    GetLineToCircle: GetLineToCircle,
    GetLineToRectangle: GetLineToRectangle,
    GetRectangleIntersection: GetRectangleIntersection,
    GetRectangleToRectangle: GetRectangleToRectangle,
    GetRectangleToTriangle: GetRectangleToTriangle,
    GetTriangleToCircle: GetTriangleToCircle,
    GetTriangleToLine: GetTriangleToLine,
    GetTriangleToTriangle: GetTriangleToTriangle,
    LineToCircle: LineToCircle,
    LineToLine: LineToLine,
    LineToRectangle: LineToRectangle,
    PointToLine: PointToLine,
    PointToLineSegment: PointToLineSegment,
    RectangleToRectangle: RectangleToRectangle,
    RectangleToTriangle: RectangleToTriangle,
    RectangleToValues: RectangleToValues,
    TriangleToCircle: TriangleToCircle,
    TriangleToLine: TriangleToLine,
    TriangleToTriangle: TriangleToTriangle

};
