/**
 * @author       Richard Davey <rich@photonstorm.com>
 * @copyright    2019 Photon Storm Ltd.
 * @license      {@link https://opensource.org/licenses/MIT|MIT License}
 */

import Line from './Line.js';
import Angle from './Angle.js';
import BresenhamPoints from './BresenhamPoints.js';
import CenterOn from './CenterOn.js';
import Clone from './Clone.js';
import CopyFrom from './CopyFrom.js';
import Equals from './Equals.js';
import Extend from './Extend.js';
import GetMidPoint from './GetMidPoint.js';
import GetNearestPoint from './GetNearestPoint.js';
import GetNormal from './GetNormal.js';
import GetPoint from './GetPoint.js';
import GetPoints from './GetPoints.js';
import GetShortestDistance from './GetShortestDistance.js';
import Height from './Height.js';
import Length from './Length.js';
import NormalAngle from './NormalAngle.js';
import NormalX from './NormalX.js';
import NormalY from './NormalY.js';
import Offset from './Offset.js';
import PerpSlope from './PerpSlope.js';
import Random from './Random.js';
import ReflectAngle from './ReflectAngle.js';
import Rotate from './Rotate.js';
import RotateAroundPoint from './RotateAroundPoint.js';
import RotateAroundXY from './RotateAroundXY.js';
import SetToAngle from './SetToAngle.js';
import Slope from './Slope.js';
import Width from './Width.js';

Line.Angle = Angle;
Line.BresenhamPoints = BresenhamPoints;
Line.CenterOn = CenterOn;
Line.Clone = Clone;
Line.CopyFrom = CopyFrom;
Line.Equals = Equals;
Line.Extend = Extend;
Line.GetMidPoint = GetMidPoint;
Line.GetNearestPoint = GetNearestPoint;
Line.GetNormal = GetNormal;
Line.GetPoint = GetPoint;
Line.GetPoints = GetPoints;
Line.GetShortestDistance = GetShortestDistance;
Line.Height = Height;
Line.Length = Length;
Line.NormalAngle = NormalAngle;
Line.NormalX = NormalX;
Line.NormalY = NormalY;
Line.Offset = Offset;
Line.PerpSlope = PerpSlope;
Line.Random = Random;
Line.ReflectAngle = ReflectAngle;
Line.Rotate = Rotate;
Line.RotateAroundPoint = RotateAroundPoint;
Line.RotateAroundXY = RotateAroundXY;
Line.SetToAngle = SetToAngle;
Line.Slope = Slope;
Line.Width = Width;

export default Line;
