/**
 * @author       Richard Davey <rich@photonstorm.com>
 * @copyright    2019 Photon Storm Ltd.
 * @license      {@link https://opensource.org/licenses/MIT|MIT License}
 */

import Rectangle from './Rectangle.js';
import Area from './Area.js';
import Ceil from './Ceil.js';
import CeilAll from './CeilAll.js';
import CenterOn from './CenterOn.js';
import Clone from './Clone.js';
import Contains from './Contains.js';
import ContainsPoint from './ContainsPoint.js';
import ContainsRect from './ContainsRect.js';
import CopyFrom from './CopyFrom.js';
import Decompose from './Decompose.js';
import Equals from './Equals.js';
import FitInside from './FitInside.js';
import FitOutside from './FitOutside.js';
import Floor from './Floor.js';
import FloorAll from './FloorAll.js';
import FromPoints from './FromPoints.js';
import GetAspectRatio from './GetAspectRatio.js';
import GetCenter from './GetCenter.js';
import GetPoint from './GetPoint.js';
import GetPoints from './GetPoints.js';
import GetSize from './GetSize.js';
import Inflate from './Inflate.js';
import Intersection from './Intersection.js';
import MarchingAnts from './MarchingAnts.js';
import MergePoints from './MergePoints.js';
import MergeRect from './MergeRect.js';
import MergeXY from './MergeXY.js';
import Offset from './Offset.js';
import OffsetPoint from './OffsetPoint.js';
import Overlaps from './Overlaps.js';
import Perimeter from './Perimeter.js';
import PerimeterPoint from './PerimeterPoint.js';
import Random from './Random.js';
import RandomOutside from './RandomOutside.js';
import SameDimensions from './SameDimensions.js';
import Scale from './Scale.js';
import Union from './Union.js';

Rectangle.Area = Area;
Rectangle.Ceil = Ceil;
Rectangle.CeilAll = CeilAll;
Rectangle.CenterOn = CenterOn;
Rectangle.Clone = Clone;
Rectangle.Contains = Contains;
Rectangle.ContainsPoint = ContainsPoint;
Rectangle.ContainsRect = ContainsRect;
Rectangle.CopyFrom = CopyFrom;
Rectangle.Decompose = Decompose;
Rectangle.Equals = Equals;
Rectangle.FitInside = FitInside;
Rectangle.FitOutside = FitOutside;
Rectangle.Floor = Floor;
Rectangle.FloorAll = FloorAll;
Rectangle.FromPoints = FromPoints;
Rectangle.GetAspectRatio = GetAspectRatio;
Rectangle.GetCenter = GetCenter;
Rectangle.GetPoint = GetPoint;
Rectangle.GetPoints = GetPoints;
Rectangle.GetSize = GetSize;
Rectangle.Inflate = Inflate;
Rectangle.Intersection = Intersection;
Rectangle.MarchingAnts = MarchingAnts;
Rectangle.MergePoints = MergePoints;
Rectangle.MergeRect = MergeRect;
Rectangle.MergeXY = MergeXY;
Rectangle.Offset = Offset;
Rectangle.OffsetPoint = OffsetPoint;
Rectangle.Overlaps = Overlaps;
Rectangle.Perimeter = Perimeter;
Rectangle.PerimeterPoint = PerimeterPoint;
Rectangle.Random = Random;
Rectangle.RandomOutside = RandomOutside;
Rectangle.SameDimensions = SameDimensions;
Rectangle.Scale = Scale;
Rectangle.Union = Union;

export default Rectangle;
