/**
 * @author       Richard Davey <rich@photonstorm.com>
 * @copyright    2019 Photon Storm Ltd.
 * @license      {@link https://opensource.org/licenses/MIT|MIT License}
 */

import Triangle from './Triangle.js';
import Area from './Area.js';
import BuildEquilateral from './BuildEquilateral.js';
import BuildFromPolygon from './BuildFromPolygon.js';
import BuildRight from './BuildRight.js';
import CenterOn from './CenterOn.js';
import Centroid from './Centroid.js';
import CircumCenter from './CircumCenter.js';
import CircumCircle from './CircumCircle.js';
import Clone from './Clone.js';
import Contains from './Contains.js';
import ContainsArray from './ContainsArray.js';
import ContainsPoint from './ContainsPoint.js';
import CopyFrom from './CopyFrom.js';
import Decompose from './Decompose.js';
import Equals from './Equals.js';
import GetPoint from './GetPoint.js';
import GetPoints from './GetPoints.js';
import InCenter from './InCenter.js';
import Perimeter from './Perimeter.js';
import Offset from './Offset.js';
import Random from './Random.js';
import Rotate from './Rotate.js';
import RotateAroundPoint from './RotateAroundPoint.js';
import RotateAroundXY from './RotateAroundXY.js';

Triangle.Area = Area;
Triangle.BuildEquilateral = BuildEquilateral;
Triangle.BuildFromPolygon = BuildFromPolygon;
Triangle.BuildRight = BuildRight;
Triangle.CenterOn = CenterOn;
Triangle.Centroid = Centroid;
Triangle.CircumCenter = CircumCenter;
Triangle.CircumCircle = CircumCircle;
Triangle.Clone = Clone;
Triangle.Contains = Contains;
Triangle.ContainsArray = ContainsArray;
Triangle.ContainsPoint = ContainsPoint;
Triangle.CopyFrom = CopyFrom;
Triangle.Decompose = Decompose;
Triangle.Equals = Equals;
Triangle.GetPoint = GetPoint;
Triangle.GetPoints = GetPoints;
Triangle.InCenter = InCenter;
Triangle.Perimeter = Perimeter;
Triangle.Offset = Offset;
Triangle.Random = Random;
Triangle.Rotate = Rotate;
Triangle.RotateAroundPoint = RotateAroundPoint;
Triangle.RotateAroundXY = RotateAroundXY;

export default Triangle;
